import { guard as pGuard } from './Predicate.js';
import { guard as strGuard } from './Str.js';
export function check(a, m) {
    if (typeof a === 'boolean' && !a && strGuard(m)) {
        throw new Error(m);
    }
    if (typeof a === 'string') {
        return (b) => {
            if (!b) {
                throw new Error(a);
            }
        };
    }
}
;
export function checkResult(a, b) {
    if (typeof a === 'boolean' && strGuard(b)) {
        return !a ? new Error(b) : true;
    }
    if (typeof a === 'string') {
        return (b) => {
            if (!b) {
                return new Error(a);
            }
            return true;
        };
    }
}
;
export function make(p, m) {
    if (pGuard(p) && arguments.length === 2) {
        return (a) => check(p(a), typeof m === 'function' ? m(a) : m);
    }
    return (y) => (a) => check(y(a), typeof p === 'function' ? String(p(a)) : p);
}
export function makeResult(p, m) {
    if (pGuard(p) && m) {
        return (a) => checkResult(p(a), typeof m === 'function' ? m(a) : m);
    }
    return (y) => (a) => checkResult(y(a), typeof p === 'function' ? p(a) : p);
}
